#include "ButtonVolume.h"

long int rotValueVolume=0, swValueVolume=0;
uint8_t stateVolume=0;

portMUX_TYPE gpioMuxVolume = portMUX_INITIALIZER_UNLOCKED;


void IRAM_ATTR isrABVolume() {
   uint8_t s = stateVolume & 3;

  portENTER_CRITICAL_ISR(&gpioMuxVolume);
    if (digitalRead(PIN_VOLUME_DT)) s |= 4;
    if (digitalRead(PIN_VOLUME_CLK)) s |= 8;
    switch (s) {
      case 0: case 5: case 10: case 15:
        break;
      case 1: case 7: case 8: case 14:
        rotValueVolume++; break;
      case 2: case 4: case 11: case 13:
        rotValueVolume--; break;
      case 3: case 12:
        rotValueVolume += 2; break;
      default:
        rotValueVolume -= 2; break;
    }
    stateVolume = (s >> 2);
   portEXIT_CRITICAL_ISR(&gpioMuxVolume);

}


void IRAM_ATTR isrSWAllVolume() {

 portENTER_CRITICAL_ISR(&gpioMuxVolume);
 swValueVolume++;
 portEXIT_CRITICAL_ISR(&gpioMuxVolume);

}


void ButtonVolume_init() {
  //
  // Set up IO pins and interrupts
  //

  pinMode(PIN_VOLUME_DT, INPUT_PULLUP);
  pinMode(PIN_VOLUME_CLK, INPUT_PULLUP);
  pinMode(PIN_VOLUME_SW, INPUT_PULLUP);

  attachInterrupt(digitalPinToInterrupt(PIN_VOLUME_DT), isrABVolume, CHANGE);
  attachInterrupt(digitalPinToInterrupt(PIN_VOLUME_CLK), isrABVolume, CHANGE);
  attachInterrupt(digitalPinToInterrupt(PIN_VOLUME_SW), isrSWAllVolume, RISING);
}

boolean ButtonVolume_IsPushed() {
  //
  // returns true is the rotary switch has been pushed on
  //
  if (swValueVolume != 0) {
    portENTER_CRITICAL_ISR(&gpioMuxVolume);
    swValueVolume = 0;
    portEXIT_CRITICAL_ISR(&gpioMuxVolume);
    return true;
  }
  else
    return false; 
}

int ButtonVolume_getTurnedNb() {
  //
  // Returns the number of ticks (when rotary switch is turned) with the sign (+ clockwise, - anticlockwise)
  //
  int value = rotValueVolume;
  if (abs(rotValueVolume) >= 4) {
    portENTER_CRITICAL_ISR(&gpioMuxVolume);
    rotValueVolume=0;
    portEXIT_CRITICAL_ISR(&gpioMuxVolume);
    return value/4;
  } else
    return 0;
}
